﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public Map1 As Map
	Dim MapDir, MapFile As String
	Public AppFolder, AppName As String
	Public DownloadPath As String
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	AppName = "Test"
	If File.ExternalWritable Then
		If File.IsDirectory( File.DirRootExternal, AppName & "/" ) = False Then
			File.MakeDir( File.DirRootExternal, AppName )
		End If
		AppFolder = File.DirRootExternal & "/" & AppName
		If File.IsDirectory( File.DirRootExternal, "Downloads/" ) = True Then
			DownloadPath = File.DirRootExternal & "/Downloads"
		End If
	Else
		If File.IsDirectory( File.DirInternal, AppName & "/" ) = False Then
			File.MakeDir( File.DirInternal, AppName )
		End If
		AppFolder = File.DirInternal & "/" & AppName
		If File.IsDirectory( File.DirInternal, "Downloads/" ) = True Then
			DownloadPath = File.DirInternal & "/Downloads"
		End If
	End If

	' copy sample map from DirAssets to DownloadPath
	If File.Exists( DownloadPath, "map_sample.png" ) = False Then
		Try
			File.Copy( File.DirAssets, "map_sample.png", DownloadPath, "map_sample.png" )
		Catch
			Log( LastException )
			ToastMessageShow( "Cannot write to " & DownloadPath & CRLF & "sample map not copied.", False )
		End Try
	End If
	Map1.Initialize
	GetSettings
End Sub

Sub Service_Start( StartingIntent As Intent )

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Public Sub GetSettings
	Dim i As Int
    
	If File.Exists( AppFolder, AppName & ".cfg" ) Then
		Map1 = File.ReadMap( AppFolder, AppName & ".cfg" )
		For i = 0 To Map1.Size - 1

			' View Map stuff
			If Map1.GetKeyAt(i) = "MapFile" Then
				MapFile = Map1.GetValueAt(i)
			End If
			If Map1.GetKeyAt(i) = "MapDir" Then
				MapDir = Map1.GetValueAt(i)
			End If

		Next
	End If
	If MapFile = "" Then MapFile = "map_sample.png"
	If MapDir = "" Then MapDir = DownloadPath

End Sub ' GetSettings

Public Sub SaveSettings
	
	Map1.Clear

	' View Map stuff
	Map1.Put( "MapFile", MapFile )
	Map1.Put( "MapDir", MapDir )
	
	File.WriteMap( AppFolder, AppName & ".cfg", Map1 )
End Sub ' SaveSettings

